#ifndef DE_CROSSOVER_STRATEGIES_H
#define DE_CROSSOVER_STRATEGIES_H

#include "de.h"
#include "../nsga2/NSGA2_DEPSO.h"

// see de_meta_fitness_function.c for definition
extern DE_CROSSOVER_STRATEGY(const de_crossover_strategy_functions[DE_META_MUTATION_COUNT][DE_META_CROSSOVER_COUNT]);

struct DECrossoverStrategyParameters {
    double CR;
    double F;
};

void de_crossover_strategy_best_1_exp(int population_size, int problem_dimension,
    struct DEPSOPosition *best, struct DEPSOPosition *population,
    struct DEPSOPosition *individual,int id, void * data);

void de_crossover_strategy_rand_1_exp(int population_size, int problem_dimension,
    struct DEPSOPosition * best, struct DEPSOPosition * population,struct DEPSOPosition *individual,
    int id, void * data);

void de_crossover_strategy_targettobest_1_exp(int population_size, int problem_dimension,
    struct DEPSOPosition * best, struct DEPSOPosition * population,struct DEPSOPosition *individual,
    int id, void * data);

void de_crossover_strategy_best_1_bin(int population_size, int problem_dimension,
    struct DEPSOPosition * best, struct DEPSOPosition * population,struct DEPSOPosition *individual,
    int id, void * data);

void de_crossover_strategy_rand_1_bin(int population_size, int problem_dimension,
    struct DEPSOPosition * best, struct DEPSOPosition * population,struct DEPSOPosition *individual,
    int id, void * data);

void de_crossover_strategy_targettobest_1_bin(int population_size, int problem_dimension,
    struct DEPSOPosition * best, struct DEPSOPosition * population,struct DEPSOPosition *individual,
    int id, void * data);

#endif // DE_CROSSOVER_STRATEGIES_H
