#include "pso_best_functions.h"
#include <cstddef>

PSO_GLOBAL_BEST_FUNCTION(const pso_global_best_functions[PSO_META_TOPOLOGY_COUNT]) = {
    NULL,
    NULL,
    pso_global_best_function
};
PSO_LOCAL_BEST_FUNCTION(const pso_local_best_functions[PSO_META_TOPOLOGY_COUNT]) = {
    pso_ring_local_best_function,
    pso_star_local_best_function,
    NULL
};

int pso_ring_local_best_function(int population_size,int id,struct DEPSOPosition * pop,void * data) {
    int ibest;
    int ineigh;

    // .. find the local best
    ibest=id;
    //Check the right-neighbour
    ineigh = id + 1;
    if (ineigh == population_size)
        ineigh = 0;

    if (pop[ineigh].fitness < pop[ibest].fitness)
        ibest = ineigh;
            
    //Check the left-neighbour
    ineigh = id - 1;
    if (ineigh < 0)
        ineigh = population_size - 1;

    if (pop[ineigh].fitness < pop[ibest].fitness)
        ibest = ineigh;

    return ibest;
}

int pso_global_best_function(int population_size,struct DEPSOPosition * pop,void * data) {
    int ibest = 0;
    int i;    

    for (i = 1; i < population_size; i++)
        if (pop[ibest].fitness > pop[i].fitness)
            ibest = i;

    return ibest;
}

int pso_star_local_best_function(int population_size,int id,struct DEPSOPosition * pop,void * data) {
    int ibest;
    int i;

    if (id == 0) { // center
        ibest = 0;
        for (i = 1; i < population_size; i++)
            if (pop[ibest].fitness > pop[i].fitness)
                ibest = i;

        return ibest;
    }

    // not center: compare only with the center
    if (pop[0].fitness <= pop[id].fitness)
        return 0;

    return id;
}
