#ifndef _RANDOM_GEN_H_
#define _RANDOM_GEN_H_

#include <cstdlib>
#include <stdint.h> 

namespace nsga2 {

/// Random Generator
class random_gen {
public:
    /// Initialize Random Generator, possibly passing the seed
    /// \param: seed
    random_gen(uint32_t seed=0);
    virtual ~random_gen();
    
    /// Random number uniformly distributed between 0 and 1
    double realu();
    /// Random floating point number uniformly distributed between low and high
    double real(double low, double high);
    /// Random integer number uniformly distributed between low and high
    int integer(int low, int high);
    /// Set random seed
    void set_seed(uint32_t seed);
    /// Get random seed
    int get_seed() const;
    
private:
    int seed;
};
}

#endif /* _RANDOM_GEN_H_ */
